// Persistence of Vision Ray Tracer Scene			
// Pov-Ray for windows unoficial version Megapov7
// Fichier : outil004.inc 
//-Pour afficher-------------------------
//object {Etabli rotate y*-90 translate <-100,10,-0>}

#version unofficial MegaPOV 0.7;
#declare Travail=0;
/*=============================     
Un ou deux burins (un large
et un normal), un marteau en bois (genre cercl de fer, avec le bois
cras au bout), et une scie qui convient pour la glace (comme les
petites scies  mtaux, mais en plus grand).
===========================================*/

#include "colors.inc"
#include "woods.inc"

#declare CentiMetre = 1;
#declare Metre = CentiMetre*100;
#declare KiloMetre = Metre*1000;

#ifndef(C_Orig)
#declare C_Orig=34/2;
#end

#ifndef (Orig)
#declare O_Orig=0;
#declare Orig=O_Orig; //ou  C_Orig //Pour l'origine au centre ou bas du maillet
#end

//----Materiel Glace  reprendre suivant la tienne
#declare T_GLACE= texture {   
        pigment {rgbft <.95,.95,1,.3,.4>}       
        normal {bumps .2 scale 1 turbulence .5}
        finish {phong .2
                reflection_type 1 reflection_min .1 reflection_max 1 
                conserve_energy
                }  
}
#declare M_GLACE = material { texture { T_GLACE} interior {ior 1.309}}
//**************************************/

//=== MAILLET =======================
#declare T_Craspouil=texture {pigment {bozo color_map{ [0.0 rgbt 1][0.2  rgbt <0.592,0.494,0.341,0.6>] [1.0 rgbt 0.4]}turbulence .6} }    
#declare T_Manche=texture {T_Wood30 rotate x*90 finish {ambient 0.3 } scale 1.2}
                  texture {T_Craspouil}  
#declare T_Marteau=texture {T_Wood10 rotate x*90 finish {ambient 0.3 diffuse .5}}
                   texture {T_Craspouil}     
#declare T_Fer=texture{pigment {color rgb <0.290,0.220,0.165>}normal { dents .3}}
#declare F=function{ noise3d( x*4, y*4, z*4 )/4 }
#declare FF=function {sqrt( x^2+y^2+z^2 ) + noise3d( x*4, y*4, z*4 )/3}
#declare F1= function{x+F(x*3,y*2,z)+.45*FF(x,y,z)} 


//---------------------------------
#declare Bout=isosurface{
 function{ F1( x, y, z )}
 threshold 1 sign 1
 accuracy .001 eval method 2
 contained_by{ sphere 0,1} 
 scale 3.5
 scale <.5,1,1>
}

#declare Marteau=merge {
difference {
       union {
       cone{<0,0,0>4<6.25,0,0>3.5}
       cone{<0,0,0>4<-6.25,0,0>3.5}
       object {Bout  translate x*6.25}
       object {Bout scale <-1,1,1>  translate x*-6.25}
        }
      prism {linear_spline  0,2,3 <-10,0><3,0><0,.25> scale <1,2,1> rotate x*-20} 
      cylinder {<5.0,0,0><5.25,0,0>3.8  }
      cylinder {<-.25,0,0><.25,0,0>4 }
      cylinder {<-5.0,0,0><-5.25,0,0>3.8  } 
       } 
      cylinder {<5.0,0,0><5.25,0,0>3.55 texture {T_Fer} }
      cylinder {<-5.0,0,0><-5.25,0,0>3.55 texture {T_Fer} } 

        cylinder {<-1.,0,0><1,0,0>3.8 } //coeur
        texture {T_Marteau rotate y*90}

}
#declare Manche=difference {
                     union {
                         cone {<0,0,0>1.8<0,34,0>1.3 }
                         sphere {<0,0,0>1.8}
                         sphere {<0,0,0>1.3 scale <1,.3,1> translate y*34}
                     }
                     torus {1.6,.3 pigment {rgb 0}scale <1,3,1> translate y*23}
                  texture {T_Manche  }
                 }
                 
                 
//-------------------------                
#declare Maillet=                 
union {                 
object {Marteau translate y*30}    
object {Manche}  
translate y*1.5
}          
//=====BURIN A ET B ===================
#declare Wrinkles = //pour  isosurface                  
 function{
  pigment{ wrinkles color_map{ [0 rgb 1][1 rgb 0] } }
 }  
#declare Crackles = //pour  isosurface                  
 function{
  pigment{ crackle color_map{ [0 rgb 1][1 rgb 0] } }
 }   
  
#declare N_Metal1=normal { function { sqrt( x^2+y*2+z )+Wrinkles( x, y, z )*2 }}
#declare N_Metal2=normal { function { sqrt( x+y+z)+Crackles( x, y, z )/2 }}
#declare N_Metal3=normal { function { sqrt( x+y*2+z*2)+Crackles( x, y, z )/2 }}

#declare F_Metal=finish { 
                        ambient 0.3
                        diffuse 0.7
                         reflection_type 1 
                         reflection_min .1 
                         reflection_max 3
                          conserve_energy
                        brilliance 9
                        specular 0.8
                        roughness 0.1
                    }
#declare F_Metal_Pointe=finish { 
                        ambient 0.3
                        diffuse 0.7
                         reflection_type 1 
                         reflection_min .1 
                         reflection_max 3
                          conserve_energy
                        brilliance 9
                        specular 0.5
                        roughness 0.1
}
                    

#declare T_Ecaille=texture {
                            pigment {bozo color_map {[0.0 rgbt 1][0.5 rgbt <1,.1,0,.1>*.5][1.0 rgbt 1 ]}}
                             finish { ambient 0.3 diffuse .6 reflection_min .1 reflection_max .2}
                             normal { N_Metal1 }
                             }
#declare T_Ecaille2=texture {
                            pigment {bozo color_map {[0.0 rgbt 1][0.5 rgbt <1,.1,0,.1>*.1][1.0 rgbt 1 ]}}
                             finish { ambient 0.3 diffuse .6 reflection_min .1 reflection_max .2}
                             normal { N_Metal1 }
                             }
#declare T_Bur1=texture{ pigment { rgb <0.658824, 0.658824, 0.658824> } 
                        normal {dents  } 
                        finish {F_Metal}
                        }
                        texture {T_Ecaille}


#declare T_Bur2= texture {pigment {rgb .1} 
                          finish {reflection_type 1 
                              reflection_min .3
                              reflection_max 3
                              conserve_energy 
                              reflection_blur .1
                              reflection_samples 8}
                          }
                 texture {pigment {dents color_map {[0 rgb <.35,.45,.59>][.5 rgb <.35,.45,.59>/2][.52 Clear][1 Clear]}}
                          normal {dents .5}
                          finish {phong .7 reflection .1}
                  scale 1
                 }
                                         
#declare T_Pointe=texture {
                    pigment { rgb <0.658824, 0.658824, 0.658824> }
                    finish {F_Metal_Pointe}
                    normal { N_Metal2}
                     }
                  texture {T_Craspouil}
#declare T_Tete=texture {
                    pigment {color rgb <0.95, 0.95, 0.95>}
                    finish {F_Metal  }
                    normal {N_Metal1}
                }
#declare T_Teteb=texture {
                    pigment {color rgb <0.95, 0.95, 0.95>}
                    finish {F_Metal  }
                    normal {N_Metal3}
                }                
//---BURIN A----------                  
#declare  Corps_Bur1 = 
 intersection
  {plane {z, 1 }  /* Rotate 90 in z axis to stand up */
   plane {z, 1 rotate < 60, 0, 0>}
   plane {z, 1 rotate <120, 0, 0>}
   plane {z, 1 rotate <180, 0, 0>}
   plane {z, 1 rotate <240, 0, 0>}
   plane {z, 1 rotate <300, 0, 0>}
   plane { x, 1}
   plane {-x, 1} 
   rotate z*90 
    texture {T_Bur1}
     scale <1,10,1 > 
  }

#declare Pointe_a = 
   union { // This isn't true CSG, it's just used for convenience
      triangle { <-0.70, 0, +0.70>, <+0.70, 0, +0.70>, <0, -1, 0>  }
      triangle { <+0.70, 0, +0.70>, <+1.41, 0, +0>, <0, -1, 0>  }
      triangle { <+1.41, 0, +0>, <+0.70, 0, -0.70>, <0, -1, 0>  }
      triangle { <+0.70, 0, -0.70>, <-0.70, 0, -0.70>, <0, -1, 0>  }
      triangle { <-0.70, 0, -0.70>, <-1.41, 0, +0>, <0, -1, 0>  }
      triangle { <-1.41, 0, +0>, <-0.70, 0, +0.70>, <0, -1, 0>  }
      scale <.8,6,.8> 
     //translate -y
     texture {T_Pointe}
}
#declare Tete_a=difference {
                sphere {0,1.35 scale <1,.4,1> texture {T_Tete}}
                sphere {0,1.345 scale <1,.4,1> translate -y*.2}
                
                }
#declare Bur1_a=
 union {
 object { Tete_a translate y*9.9}
 object { Pointe_a  translate y*-10}
 object { Corps_Bur1 }
 scale <1.2,1,1.2>
  translate y*15
}
//-- BURIN B -----------------
#declare Corps_Bur1_b=object {Corps_Bur1 scale <1.2,1,1.2>}
#declare Pointe_b=isosurface { function  {"Algbr_Cyl1" <1, 1, 0, 0, 0>}
                                            accuracy 0.001
                                            contained_by{sphere {0,1.2}}
                                            rotate z*90
                                            rotate y*90
                                            clipped_by {box {<-2,2,-2>,<2,0,2>}}
                                            scale <.65,2.5,.4>*3
                        } 
#declare Bout = 
   union { 
      triangle { <-0.70, 0, +0.70>, <+0.70, 0, +0.70>, <0, -1, 0>  }
      triangle { <+0.70, 0, +0.70>, <+1.41, 0, +0>, <0, -1, 0>  }
      triangle { <+1.41, 0, +0>, <+0.70, 0, -0.70>, <0, -1, 0>  }
      triangle { <+0.70, 0, -0.70>, <-0.70, 0, -0.70>, <0, -1, 0>  }
      triangle { <-0.70, 0, -0.70>, <-1.41, 0, +0>, <0, -1, 0>  }
      triangle { <-1.41, 0, +0>, <-0.70, 0, +0.70>, <0, -1, 0>  }
      scale <1.1,2,1.1> 
     texture {T_Bur1}
}                         
#declare Pointe_b=union {object {Bout translate y*7}
                         object {Pointe_b }
                         texture {T_Pointe }
                         }
#declare Tete_b=difference {
                sphere {0,1.35*1.2  scale <1,.4,1> }
                sphere {0,1.345*1.2 scale <1,.4,1> translate -y*.2}  
                texture {T_Teteb scale 2}
                }
                
#declare Bur1_b=union {
object { Tete_b translate y*9.9}
 object { Pointe_b translate y*-17}
 object { Corps_Bur1_b}
 scale <1.1,1,1.1>
 translate y*16.6
}
//=== SCIE1 et SCIE2 ========================
#declare F_Metal_Lame=finish { 
                        ambient 0.3
                        diffuse 0.7
                         reflection_type 1 
                         reflection_min .3
                         reflection_max 3
                         conserve_energy 
                         reflection_blur .1
                         reflection_samples 8
                        brilliance 9
                        specular 0.3
                        roughness 0.1
                        irid { 
                        0.50
			thickness .1
			turbulence .4
			} 
                    }

#declare T_Lame=texture {
                    pigment { rgb <0.658824, 0.658824, 0.658824> }
                    finish {F_Metal_Lame }
                   
                     }
                 // texture {T_Craspouil}
#declare T_Poignee=texture {T_Wood10 rotate y*90 finish {ambient 0.3 diffuse .5} translate y*.5 }
                  // texture {T_Craspouil}     
                 
//------------------------------------------                 
#declare Dent=triangle {<0, -3, 0>, <-1, 0, 0>, <1, 0, 0> }
#declare i=1;
#declare Agl=2;
#declare Angl=Agl;
#declare Dents=merge {
                #while (i<75)
                #if (Angl=Agl) #declare Angl=-Agl;#else #declare Angl =Agl; #end
                object { Dent  rotate x*Angl translate x*-50+x*i}
                #declare i=i+2;
                #end
              }
#declare Clous=cylinder {<0,0,-.51><0,0,.51>.5 texture {T_Tete}}               
#declare Lame=merge {
difference {
                box{ <-50,0,-.1><30,20,0.1> }
                box{ <-80,18,-.2><60,50,0.2> rotate z*12 }   
                texture {T_Lame}  
                translate y*3 
                }
                object { Dents translate y*3}
   texture {T_Lame}
   }
#declare IsoP=isosurface { function {"Devils_curve2d" <1, 1.5, 1.52, 0, 0, 0>}
                                            accuracy 0.001
                                            max_gradient 20
                                            contained_by{box {<-2,-2,-.5><2,2,.5>}}   
                                            //rotate y*90
                                            rotate z*90
                        } 
#declare Poignee=union {object {IsoP} box{<-3.5,-2,-.5><0,2,.5>}object {IsoP translate x*-2} scale <1.2,1,1>}
#declare Poignee=difference {object {Poignee} sphere {0,1 scale <1,1.5,2>} texture {T_Poignee }  scale <4,4.5,1>}
#declare Poignee=union {object {Poignee}  object {Clous translate <-10,5,0>} object {Clous translate <-15,0,0>} object {Clous translate <-10,-5,0>} }
#declare Scie1=union { object {Poignee translate <35,13.9,0>} object {Lame} scale <1,1,2> translate <0,0,-.5>} 
   
//-------SCIE2-------------------------------

#declare Dent=triangle {<0, -4, 0>, <-1, 0, 0>, <1, 0, 0> }
#declare i=1;
#declare Agl=2;
#declare Angl=Agl;
#declare Dents=merge {
                box {<-42,0,-.1><42,4,.1>}
                #while (i<80)
                #if (Angl=Agl) #declare Angl=-Agl;#else #declare Angl =Agl; #end
                object { Dent  rotate x*Angl translate x*-40+x*i}
                #declare i=i+2;
                #end
                texture {T_Lame}
              }
#declare Clou=cylinder {<0,0,-1><0,0,1>1 texture {T_Tete}}

#declare Corps_Scie=union {
                cylinder {<-40,4,0><-40,30,0>2 }
                cylinder {<40,4,0><40,30,0>2 }
                cone {<40,4,0>2<40,0,0>1 }
                 cone {<-40,4,0>2<-40,0,>1}
                torus {10,2 rotate x*-90 clipped_by {box {<-20,0,-5><0,20,5>}} translate <-30,30,0>}
                torus {10,2 rotate x*-90 clipped_by {box {< 0,0,-5><20,20,5>}} translate < 30,30,0>}
                cylinder {<-30,40,0><30,40,0>2}
               texture {T_Bur2}
               scale <1,1,.5>
}
#declare Scie2=union {
object {Corps_Scie}
object {Clou translate <-40,1.5,0>}
object {Clou translate < 40,1.5,0>}
object { Dents }   
}

//=====================PLAID===========================================
#declare P_Franges = pigment {
    image_map { png "maps\franges_plaid"  interpolate 2 }
    scale <1,1,1>
}

#declare P_Plaid = pigment {image_map { png "maps\text_plaid" once interpolate 2 }}

#declare T_Frange=texture{
        pigment {
        pigment_pattern { P_Franges }
        pigment_map {
            [0 rgbt <0,0,0,1>]
            [1 P_Plaid]
        }
    }
    finish { ambient 0.3 diffuse .6}
    normal {quilted .5 scale .002}
}

#declare Plaid = mesh {
	//#include "meshes\plaid_s.msh"
	#include "meshes\machin.msh"
	uv_mapping  
	texture {T_Frange}
	texture {pigment {aoi color_map {[0 Clear][.4 Clear][.45 White filter .5][.5 White][1 SteelBlue]}}}
}
//------------------------------------------------------------------------
#declare Etabli=
union { 
object {Plaid scale <1,.8,1> translate y*10} //rotate y*20    translate y*.001
object {Maillet rotate x*-85 rotate y*  5 translate <- 3,1,-5>}// rotate y*20 translate <-10,0,0>}
object {Bur1_a  rotate x*-90 rotate y* 10 translate <-20,1,-10> }// rotate y*15  translate <-5,0.2,-10> } 
object {Bur1_b  rotate x* 90 rotate y*-40 translate <-31,1,-40>}// rotate y*10  }// <20,0,-3>
object {Scie2  scale <.5,.5,1> rotate x* 90 rotate y*110 rotate z*-10 translate <15,4,-25>}//  }// ou Scie1 <30,0,0>
}
//==========================================================================

//==Pour afficher==============================
//object {Etabli rotate y*-90 translate <-100,10,-0>}
